<script lang="ts">
  import Button from '$lib/components/Button.svelte';
  import TextField from '$lib/components/fields/TextField.svelte';
  import SelectField from '$lib/components/fields/SelectField.svelte';
  import { axiosInstance } from '$lib/config/index.js';
  import FileField from '$lib/components/fields/FileField.svelte';

  export let research: any = null,
    categories: any = [];

  let id: number,
    name: string,
    category: any,
    attachment: any;

  if (research) {
    id = research.id;
    name = research.name;
    category = research.researchCategory;
  }

  async function handleSubmit() {
    if (name && attachment) {
      let attachmentId = null;

      try {
        const resAttachment = await axiosInstance[attachment.id ? 'patch' : 'post'](`/attachment${attachment.id ? `/${attachment.id}` : ''}`, {
          file: attachment[0]
        }, {
          headers: {
            'Content-Type': 'multipart/form-data'
          }
        });

        attachmentId = resAttachment.data.data.id;

        if (resAttachment.status === 201 || resAttachment.status === 200) {
          if (typeof category === 'string') {
            const resCategory = await axiosInstance.post(`/researchcategory`, {
              name: category
            });

            if (resCategory.status === 201 || resCategory.status === 200) {
              const res = await axiosInstance[id ? 'patch' : 'post'](`/research${id ? `/${id}` : ''}`, {
                name,
                researchCategoryId: resCategory.data.id,
                attachmentId
              });

              if (res.status === 201) {
                window.location.href = '/admin/research';
              }

              if (res.status === 200) {
                alert('Успешно сохранено.');
              }
            }
          } else {
            const res = await axiosInstance[id ? 'patch' : 'post'](`/research${id ? `/${id}` : ''}`, {
              name,
              researchCategoryId: category.id,
              attachmentId
            });

            if (res.status === 201) {
              window.location.href = '/admin/research';
            }

            if (res.status === 200) {
              alert('Успешно сохранено.');
            }
          }
        }
      } catch (err: any) {
        console.error(err);

        await axiosInstance.delete(`/attachment/${attachmentId}`);

        switch (err.response.status) {
          case 400:
            alert('Неверные данные');
            break;
          default:
            alert('Возникла ошибка. Попробуйте повторить действие.');
        }
      }
    }
  }
</script>

<form
    method="post"
    on:submit|preventDefault={handleSubmit}
    class="{$$props.class} space-y-6 mx-auto max-w-screen-xl"
>
    <h1 class="text-6xl text-center mb-2 font-serif">
        {#if research}
            Изменение записи
            <p class="text-lg text-neutral-600"><span class="select-none">ID:</span>{id}</p>
        {:else}
            Создание записи
        {/if}
    </h1>

    <TextField label="Наименование" name="name" bind:value={name}/>
    <SelectField label="Категория" name="category" bind:value={category} options={categories}/>
    <FileField label="Файл" name="attachment" bind:files={attachment}/>

    <section class="flex justify-center gap-6">
        <a href="/admin/research">
            <Button transparent>Отменить</Button>
        </a>
        <Button>
            {#if research}
                Изменить
            {:else}
                Создать
            {/if}
        </Button>
    </section>
</form>